package com.eactive.eai.agent.transformer;

import java.util.Vector;

import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.common.util.Logger;
import com.eactive.eai.transformer.transform.TransformManager;

public class ReloadTransformListCommand extends Command {
	private static final long serialVersionUID = 1L;

	public ReloadTransformListCommand() {
		super("ReloadTransformListCommand");
	}

	public Object execute() throws CommandException {
		Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
		if (logger.isInfo())
			logger.info(this.name + " is executed");

		if (!(args instanceof Vector)) {
			String rspErrorCode = "RECEAIMCM001";
			String msg = makeException(rspErrorCode, null);
			if (logger.isError())
				logger.error(msg);
			throw new CommandException(msg);
		}

		try {
			TransformManager manager = TransformManager.getManager();

			String transformName = "";
			Vector transformVt = (Vector) args;

//            String layoutName = "";
			for (int i = 0; i < transformVt.size(); i++) {
				transformName = (String) transformVt.get(i);
				if (transformName != null) {
					manager.reload(transformName);
					if (logger.isWarn())
						logger.warn("ReloadTransformListCommand ] " + transformName + " all Transform info Reload.");
				}
			}
		} catch (Exception e) {
			String rspErrorCode = "RECEAIMCM002";
			String msg = makeException(rspErrorCode, e);
			if (logger.isError())
				logger.error(msg, e);
			throw new CommandException(msg);
		}
		return "success";

	}

//    public static void main(String[] args)throws Exception{
//        
//        TransformManager manager = TransformManager.getManager();
//        
//        Command command = new ReloadTransformListCommand();
//        command.setArgs("");
//        AgentUtil.broadcast(command);
//        
//    }
}
